#include <libpki/pki.h>

int main (int argc, char *argv[]) {

	PKI_MEM_STACK *sk = NULL;
	PKI_MEM *obj = NULL;

	URL * url = NULL;
	char *outurl_s = NULL;

	int debug = 0;

	if( !argv[1] ) {
		printf("\n  USAGE: url-tool <URL> [outfile]\n\n");
		return(1);
	}

	if((url = URL_new( argv[1])) == NULL ) {
		printf("\nERROR, not a valid URL!\n\n");

		printf("  USAGE: url-tool <URL> [outfile]\n\n");
		return (1);
	}

	if ( (argc >= 2 ) && ( argv[2] != NULL )) {
		outurl_s = argv[2];
	} else {
		outurl_s = "fd://1";
	}

	if( debug ) {
		if(( PKI_log_init (PKI_LOG_TYPE_STDERR, PKI_LOG_INFO, NULL,
        	              PKI_LOG_FLAGS_ENABLE_DEBUG, NULL )) == PKI_ERR) {
        	        exit(1);
        	}
	}

	if((sk = URL_get_data ( argv[1] , 100, 0 )) == NULL ) {
		fprintf(stderr, "ERROR, can not retrieve data!\n\n");
		return(-1);
	}

	while( (obj = PKI_STACK_MEM_pop ( sk )) != NULL ) {
		URL_put_data ( outurl_s, obj, NULL, NULL, 0, 0 );
	}

	return 0;
}
